CON
  _clkmode = xtal1 + pll16x             '80 MHz
  _xinfreq = 5_000_000

' -------  Pin assigments ------
' ground           DB9 pin 5 on Firecracker
  dtr   = 0       'DB9 pin 4 on Firecracker
  rts   = 1       'DB9 pin 7 on Firecracker

'demo house code and unit
  house = "C"
  unit  = 3
 
VAR
  long useser           ' USB serial connection detected T/F
  long debugsw          ' control output to Parallax Terminal
  long temp

OBJ
  fc            : "X10_CM17A"         'X10 Firecracker                                   
  Debug         : "FullDuplexSerial"                                         

PUB Main | cntr
  useser := false
  if ina[31] == 1                      ' RX (pin 31) is high if USB is connected
    Debug.start(31, 30, 0, 57600)      ' ignore tx echo on rx
    waitcnt(clkfreq * 3 + cnt)         ' Pause for FullDuplexSerial.spin to initialize
    useser := true                     ' Debug serial connection is active
    debugsw := true
  else
    outa[30] := 0                      ' Force Propeller Tx line LOW if USB not connected

  Debug.tx(16)  'cls
  fc.start(dtr, rts)                    'initialize object

  temp := fc.sendcmd(house, fc#On, unit)             'turn demo unit on
  Debug.bin(temp,16)
  debug.tx(" ")
  debug.hex(temp,4)
  debug.str(string(" Unit on"))
  debug.tx(13)
  waitcnt(clkfreq * 2 + cnt) 

  repeat cntr from 1 to 5
    temp := fc.sendcmd(house, fc#Dim, fc#nullunit)   'dim
    Debug.bin(temp,16)
    debug.tx(" ")
    debug.hex(temp,4)
    debug.str(string(" Unit dim"))
    debug.tx(13)
    waitcnt(clkfreq * 1 + cnt)
     
  waitcnt(clkfreq * 2 + cnt)
  repeat cntr from 1 to 5
    temp := fc.sendcmd(house, fc#Bright, fc#nullunit) 'bright
    Debug.bin(temp,16)
    debug.tx(" ")
    debug.hex(temp,4)
    debug.str(string(" Unit bright"))
    debug.tx(13)
    waitcnt(clkfreq * 1 + cnt)

  waitcnt(clkfreq * 2 + cnt)
  temp := fc.sendcmd(house, fc#Off, unit)             'turn demo unit off
  Debug.bin(temp,16)
  debug.tx(" ")
  debug.hex(temp,4)
  debug.str(string(" Unit off"))
  debug.tx(13)

  waitcnt(clkfreq * 2 + cnt)
  temp := fc.sendcmd("c", fc#AllLightsOn, fc#nullunit)  'all lights on
  Debug.bin(temp,16)
  debug.tx(" ")
  debug.hex(temp,4)
  debug.str(string(" All Lights on"))
  debug.tx(13)

  waitcnt(clkfreq * 2 + cnt)
  temp := fc.sendcmd("c", fc#AllUnitsOff, fc#nullunit)   'all units off
  Debug.bin(temp,16)
  debug.tx(" ")
  debug.hex(temp,4)
  debug.str(string(" All units off"))
  debug.tx(13)

  repeat
    waitcnt(clkfreq * 2 + cnt)
   